scala

# language

#### object language

The `scala.language` object controls the language features available to the programmer, as proposed in the SIP-18 document.

Each of these features has to be explicitly imported into the current scope to become available:

    import language.postfixOps // or language._
    List(1, 2, 3) reverse

The language features are:

- `dynamics` enables defining calls rewriting using the `Dynamic` trait
- `postfixOps` enables postfix operators
- `reflectiveCalls` enables using structural types
- `implicitConversions` enables defining implicit methods and members
- `higherKinds` enables writing higher-kinded types
- `existentials` enables writing existential types
- `experimental` contains newer features that have not yet been tested in production

Source
  language.scala

Linear Supertypes
AnyRef, Any
Ordering

1. Grouped
2. Alphabetic
3. By inheritance

Inherited

1. language
2. AnyRef
3. Any

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

5. #### final def ==(arg0: Any): Boolean

   Test two objects for equality.

   Test two objects for equality. The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     Any

6. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown
     ClassCastException

     if the receiver object is not an instance of the erasure of type `T0`.

7. #### def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws ( ... )
   Note

     not specified by SLS as a member of AnyRef

8. #### implicit lazy val dynamics: dynamics

   Where enabled, direct or indirect subclasses of trait scala.

   Where enabled, direct or indirect subclasses of trait scala.Dynamic can be defined. Unless dynamics is enabled, a definition of a class, trait, or object that has Dynamic as a base trait is rejected. Dynamic member selection of existing subclasses of trait Dynamic are unaffected; they can be used anywhere.

   Why introduce the feature? To enable flexible DSLs and convenient interfacing with dynamic languages.

   Why control it? Dynamic member selection can undermine static checkability of programs. Furthermore, dynamic member selection often relies on reflection, which is not available on all platforms.

9. #### final def eq(arg0: AnyRef): Boolean

   Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

   Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

   The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

   - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
   - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
   - `null.eq(null)` returns `true`.

   When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

   returns

     `true` if the argument is a reference to the receiver object; `false` otherwise.

   Definition Classes
     AnyRef

10. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

11. #### implicit lazy val existentials: existentials

    Only where enabled, existential types that cannot be expressed as wildcard types can be written and are allowed in inferred types of values or return types of methods.

    Only where enabled, existential types that cannot be expressed as wildcard types can be written and are allowed in inferred types of values or return types of methods. Existential types with wildcard type syntax such as `List[_]`, or `Map[String, _]` are not affected.

    Why keep the feature? Existential types are needed to make sense of Java’s wildcard types and raw types and the erased types of run-time values.

    Why control it? Having complex existential types in a code base usually makes application code very brittle, with a tendency to produce type errors with obscure error messages. Therefore, going overboard with existential types is generally perceived not to be a good idea. Also, complicated existential types might be no longer supported in a future simplification of the language.

12. #### object experimental

    The experimental object contains features that have been recently added but have not been thoroughly tested in production yet.

13. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws ( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

14. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

15. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

16. #### implicit lazy val higherKinds: higherKinds

    Only where this flag is enabled, higher-kinded types can be written.

    Only where this flag is enabled, higher-kinded types can be written.

    Why keep the feature? Higher-kinded types enable the definition of very general abstractions such as functor, monad, or arrow. A significant set of advanced libraries relies on them. Higher-kinded types are also at the core of the scala-virtualized effort to produce high-performance parallel DSLs through staging.

    Why control it? Higher kinded types in Scala lead to a Turing-complete type system, where compiler termination is no longer guaranteed. They tend to be useful mostly for type-level computation and for highly generic design patterns. The level of abstraction implied by these design patterns is often a barrier to understanding for newcomers to a Scala codebase. Some syntactic aspects of higher-kinded types are hard to understand for the uninitiated and type inference is less effective for them than for normal types. Because we are not completely happy with them yet, it is possible that some aspects of higher-kinded types will change in future versions of Scala. So an explicit enabling also serves as a warning that code involving higher-kinded types might have to be slightly revised in the future.

17. #### implicit lazy val implicitConversions: implicitConversions

    Only where enabled, definitions of implicit conversions are allowed.

    Only where enabled, definitions of implicit conversions are allowed. An implicit conversion is an implicit value of unary function type `A => B`, or an implicit method that has in its first parameter section a single, non-implicit parameter. Examples:

        implicit def stringToInt(s: String): Int = s.length
        implicit val conv = (s: String) => s.length
        implicit def listToX(xs: List[T])(implicit f: T => X): X = ...

    implicit values of other types are not affected, and neither are implicit classes.

    Why keep the feature? Implicit conversions are central to many aspects of Scala’s core libraries.

    Why control it? Implicit conversions are known to cause many pitfalls if over-used. And there is a tendency to over-use them because they look very powerful and their effects seem to be easy to understand. Also, in most situations using implicit parameters leads to a better design than implicit conversions.

18. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

19. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

20. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

21. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

22. #### implicit lazy val postfixOps: postfixOps

    Only where enabled, postfix operator notation `(expr op)` will be allowed.

    Only where enabled, postfix operator notation `(expr op)` will be allowed.

    Why keep the feature? Several DSLs written in Scala need the notation.

    Why control it? Postfix operators interact poorly with semicolon inference. Most programmers avoid them for this reason.

23. #### implicit lazy val reflectiveCalls: reflectiveCalls

    Only where enabled, accesses to members of structural types that need reflection are supported.

    Only where enabled, accesses to members of structural types that need reflection are supported. Reminder: A structural type is a type of the form `Parents { Decls }` where `Decls` contains declarations of new members that do not override any member in `Parents`. To access one of these members, a reflective call is needed.

    Why keep the feature? Structural types provide great flexibility because they avoid the need to define inheritance hierarchies a priori. Besides, their definition falls out quite naturally from Scala’s concept of type refinement.

    Why control it? Reflection is not available on all platforms. Popular tools such as ProGuard have problems dealing with it. Even where reflection is available, reflective dispatch can lead to surprising performance degradations.

24. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

25. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

26. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws ( ... )

27. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws ( ... )

28. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws ( ... )

### Inherited from AnyRef

### Inherited from Any

### Language Features

### Experimental Language Features

### Ungrouped